<?php
/**
* @fichier: galerie.php
* @version: MyPlugBox V1.0.1
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
* Author: Donnie Adams (pluggingit.com)
* @adapter: PatMax - http://www.patmax.info
**/

error_reporting(E_ALL ^ E_NOTICE);
// set_magic_quotes_runtime(0);

$pb_paths['root']      = str_replace('\\', '/', dirname(__FILE__)) . '/';
$pb_paths['plug_db']   = $pb_paths['root'] . 'plugs.txt';
$pb_paths['banned_db'] = $pb_paths['root'] . 'banned.txt';
$pb_paths['config_db'] = $pb_paths['root'] . 'config.php';

require_once($pb_paths['config_db']);

switch ((empty($_REQUEST['act']) ? '' : $_REQUEST['act']))
{
	// Redirect to plugger's web site
	case 'go':
	if (!empty($_GET['id']) && is_numeric($_GET['id']))
	{
		// Find plug and update click count
		if ($plugs = @file($pb_paths['plug_db']))
		{
			$token = '|' . intval($_GET['id']);
			foreach ($plugs as $key => $plug)
			{
				if (strpos($plug, $token) !== false)
				{
					$plug			= explode('|', $plug);
					$plug[2]		= $plug[2] + 1;
					$plugs[$key]	= implode('|', $plug);
					// Write plugs with updated click count to file.
					$plugs = implode('', $plugs);
					ignore_user_abort(true);
					if ($fp = @fopen($pb_paths['plug_db'], 'wb'))
					{
						@flock($fp, LOCK_EX);
						$bytes = fwrite($fp, $plugs, strlen($plugs));
						@flock($fp, LOCK_UN);
						fclose($fp);
					}
					ignore_user_abort(false);
					if (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') === false)
					{
						header('Location: http://' . $plug[1]);
					}
					else
					{
						header('Refresh: 0; http://' . $plug[1]);
					}
					exit();
					break;
				}
			}
			die('<strong>Redirection Failed</strong>: L\'ID n\'existe pas dans la base de donnes.');
		}
		$filename = basename($pb_paths['plug_db']);
		die("<strong>Redirection Failed</strong>: Le fichier <em>{$filename}</em> n\'existe pas dans la base de donnes ou n\'est pas lisible.");
	}
	die('<strong>Redirection Failed</strong>: Caractre d\'ID invalide.');
	break;

	$plugs = array_merge(
	array("{$button_url}|{$website_url}|0|{$_SERVER['REMOTE_ADDR']}|".time()."\n"),
	(array)$plugs);
	if (sizeof($plugs) > $pb_cfg['max_plugs'])
	{
		$plugs = array_slice($plugs, 0, $pb_cfg['max_plugs']);
	}
	ignore_user_abort(true);
	if ($fp = @fopen($pb_paths['plug_db'], 'wb'))
	{
		$plugs = implode('', $plugs);
		@flock($fp, LOCK_EX);
		$result = fwrite($fp, $plugs, strlen($plugs));
		@flock($fp, LOCK_UN);
		fclose($fp);
	}
	unset($plugs);
	ignore_user_abort(false);
	if (strpos($_SERVER['SERVER_SOFTWARE'], 'Microsoft-IIS') === false)
	{
		header('Location: ' . $pb_cfg['site_url']);
	}
	else
	{
		header('Refresh: 0; ' . $pb_cfg['site_url']);
	}
	exit();
	break;

	// Print plugs to web browser
	default:
	if ($plugs = @file($pb_paths['plug_db']))
	{
		$plug_count = count($plugs);
		if ($pb_cfg['max_plugs'] < $plug_count)
		{
			$plugs = array_slice($plugs, 0, (int)$pb_cfg['max_plugs']);
		}
		if ($plug_count > 1)
		{
			switch (strtoupper($pb_cfg['display_order']))
			{
				case 'RANDOM':
				shuffle($plugs);
				break;
				case 'ASC':
				$plugs = array_reverse($plugs);
				break;
			}
		}
?>
<center>
<?php
		foreach ($plugs as $plug)
		{
			@list($button_url, $website_url, $click_count, $ip_address, $timestamp) = explode('|', rtrim($plug));
			$redirect_url = $pb_cfg['base_url'] . 'plug.php?act=go&amp;id=' . $timestamp;
			$plug_date    = @date($pb_cfg['date_format'], $timestamp);
			echo "<a href='{$redirect_url}' target='_blank'><img src='http://{$button_url}' " .
				"border='0' width='{$pb_cfg['button_width']}' height='{$pb_cfg['button_height']}' " .
				"title='Clicks: {$click_count} Date: {$plug_date} URL: {$website_url}' " .
				"alt='' /></a>\n";
		}
?>
</center>
<?php
		unset($plugs, $pb_cfg);
	}
}
?>